/****************************************
 * Conversion Midi vers DMX
 * Interface-Z
 * Actuators Midi to DMX
 *****************************************/

// Importer la library the Midibus
// http://smallbutdigital.com/themidibus.php
import themidibus.*; 

MidiBus myBus; 

int[] lampes = new int[4];
int compteur = 0;

void setup()
{
  size(260, 200);
  noStroke();
  smooth();

  // Liste des peripheriques Midi disponibles sur l'ordinateur
  // Displaying Midi devices existing on the computer  
  MidiBus.list(); 

  // Ouverture de port (this, In, Out)
  // Choisir le numero du peripherique dans la liste
  // In et Out etant les numeros des peripheriques entrant (capteurs) et sortant (actionneurs).
  // Open Midi port (this, In, Out)
  // Choose the appropriate Midi device from the list
  // In and Out being the corresponding In (sensors) and Out (actuators) devices.
  myBus = new MidiBus(this, -1, 3);
  // -1 pour ne pas ouvrir ce port
  // -1 in order not to open this port
}

void draw()
{
  background(0);
  compteur = (compteur + 1) % 128;
  // Envoie de commandes graduelles en boucle 
  // en decalage sur 4 canaux DMX.
  // Sending values on 4 DMX channels.
  // La carte doit etre configuree sur le premier canal Midi
  for(int i=0; i<4; i=i+1) {
    lampes[i]=(compteur+i*20)%128;
      // sendControllerChange(canal, numero, valeur)
      // sendControllerChange(channel, number, value)
    myBus.sendControllerChange(0, i, lampes[i]);
    
    // Representation des consignes envoyees sur des sliders.
    // Displaying sent values on sliders.
    fill(30, 30, 240, 200);
    rect(20+22*i, 40, 20, 128);
    fill(130, 130, 240, 200);
    rect(20+22*i, 40+127-lampes[i], 20, lampes[i]);
  }
}

